#include "../../src/Battling/Library/BattleStatCalculator.hpp"
#include "../Core.hpp"
using namespace CreatureLib::Battling;

export const BattleStatCalculator* CreatureLib_BattleStatCalculator_Construct() { return new BattleStatCalculator(); }

export void CreatureLib_BattleStatCalculator_Destruct(const BattleStatCalculator* p) { delete p; }

export u8 CreatureLib_BattleStatCalculator_CalculateFlatStat(u32& out, const BattleStatCalculator* p,
                                                             Creature* creature, CreatureLib::Library::Statistic stat) {
    Try(out = p->CalculateFlatStat(creature, stat);)
}
export u8 CreatureLib_BattleStatCalculator_CalculateBoostedStat(u32& out, const BattleStatCalculator* p,
                                                                Creature* creature,
                                                                CreatureLib::Library::Statistic stat) {
    Try(out = p->CalculateBoostedStat(creature, stat);)
}