#include "../../src/Battling/ScriptHandling/ItemUseScript.hpp"
#include "../Core.hpp"
using namespace CreatureLib::Battling;

export void CreatureLib_ItemUseScript_Destruct(ItemUseScript* p) { delete p; }
export u8 CreatureLib_ItemUseScript_IsItemUsable(ItemUseScript* p, u8& out) { Try(out = p->IsItemUsable()) }
export u8 CreatureLib_ItemUseScript_IsCreatureUseItem(ItemUseScript* p, u8& out) { Try(out = p->IsCreatureUseItem()) }

export u8 CreatureLib_ItemUseScript_IsUseValidForCreature(ItemUseScript* p, Creature* creature, u8& out) {
    Try(out = p->IsUseValidForCreature(creature))
}

export u8 CreatureLib_ItemUseScript_IsHoldable(ItemUseScript* p, u8& out) { Try(out = p->IsHoldable()) }

export u8 CreatureLib_ItemUseScript_OnUse(ItemUseScript* p, Battle* battle) { Try(p->OnUse(battle)) }
export u8 CreatureLib_ItemUseScript_OnCreatureUse(ItemUseScript* p, Creature* creature, bool isBattle) {
    Try(p->OnCreatureUse(creature, isBattle))
}